"""Class to query database info

This is Gadfly specific.

Author: Paulo Eduardo Neves <neves@inf.puc-rio.br>
        Philipp Auersperg<phil@bluedynamics.com>
"""

import InfoBase
import string
from string import join, split, find, strip

class Info(InfoBase.Info):
    #Are these commands in the SQL standard?
    queryTables = 'show tables'
    queryColumns = 'show columns from %s' 

    def type(self, table, column):
	"""Maps database types to #sqlvar types

	"""
	#print 'type:',table,column
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	type = string.lower(colInfo[1]) #[1] is the pos for the type info

        #print 'type:',type
	if ((string.find(type, "char") != -1) or #gets char and varchar
	    (string.find(type, "set")  != -1) or 
	    (string.find(type, "text") != -1) or
	    (string.find(type, "date") != -1) or
	    (string.find(type, "time") != -1) or
	    (string.find(type, "enum") != -1) ):

	    if self.nullable(table, column): 
		#I'm assuming that if a string field can be null,
		#there's no sense for it to be empty
		return 'nb'
	    else:
		return 'string'
	if (string.find(type, "int") != -1):
	    return 'int'
	
	#else
	return 'float'
    
    def nullable(self, table, column):
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break

	#print 'colInfo:',colInfo,colInfo[3]
	try:
            if colInfo[3] == "with Null": #2 is the pos for null info
                #print 'optional'
                return 'optional'
        except:
            pass
	return ''

    def getTablesNames(self):
	self.tablesData=[]
	
	tabs = self.connection().tables()
	#print 'tabs:',tabs

	
	for cur in tabs:
        	try:
			self.tablesData.append(cur['TABLE_NAME'])
		except:
			pass

	return  self.tablesData

    def getColumnsNames(self, tables):
	"""Query the columns names and returns a dictionary
	where the key is the table name and the value is the columns list"""


	tableColumns = {}
	colspertab=[]

	
	for i in tables:
	    	cols=self.connection().columns(i)
		
		for col in cols:
			line=[col['Name'],col['Type'],'%d' % (col['Precision']) ,col['Nullable']]
			colspertab.append(line)
	
		
	    	self.columnsData[i] = colspertab
	    	columns = []
	    	for j in self.columnsData[i]:
			if not self._identitycol(j): #needed by some DBs
		    		columns.append(self._columnName(j))

		tableColumns[i] =  columns

	return tableColumns

