"""Class to query database info

This is MySQL specific.

Author: Paulo Eduardo Neves <neves@inf.puc-rio.br>
"""

import InfoBase
import string

class Info(InfoBase.Info):
    #Are these commands in the SQL standard?
    queryTables = 'show tables'
    queryColumns = 'show columns from %s' 

    def type(self, table, column):
	"""Maps database types to #sqlvar types

	This looks like really MySQL specific
	"""
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	type = string.lower(colInfo[1]) #[1] is the pos for the type info
	if ((string.find(type, "char") != -1) or #gets char and varchar
	    (string.find(type, "set")  != -1) or 
	    (string.find(type, "text") != -1) or
	    (string.find(type, "date") != -1) or
	    (string.find(type, "time") != -1) or
	    (string.find(type, "enum") != -1) ):

	    if self.nullable(table, column): 
		#I'm assuming that if a string field can be null,
		#there's no sense for it to be empty
		return 'nb'
	    else:
		return 'string'
	if (string.find(type, "int") != -1):
	    return 'int'
	
	#else
	return 'float'
    
    def nullable(self, table, column):
	"This is really MySQL specific"
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	if colInfo[2] == "YES": #2 is the pos for null info
	    return 'optional'
	return ''

