"""Class to query database info

This is Oracle specific,  tested against Oracle 8.0.5.

Author: Anthony Baxter <anthony@interlink.com.au>
"""

import InfoBase
import string

class Info(InfoBase.Info):
    # mmm... standards.
    queryTables = 'select table_name from user_tables'
    queryColumns = "select column_name, data_type, data_length, nullable from user_tab_columns where table_name = '%s' "


    def type(self, table, column):
	"""Maps database types to #sqlvar types

	Should be smarter (i.e. use type=nb)
	"""
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	# in `queryColumns', second col is type
	type = string.lower(colInfo[1]) 
	if ((string.find(type, "char") != -1) or #gets char and varchar
	    (string.find(type, "date") != -1) or
	    (string.find(type, "enum") != -1) ):
	    if self.nullable(table, column):
		return 'nb'
	    else:
		return 'string'
	if ( (string.find(type, "rowid") != -1) or
	    (string.find(type, "number") != -1) ):
	    return 'int'
	
	#else
	return 'float'
    
    def nullable(self, table, column):
	"This is really Oracle specific"
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	if colInfo[3] == "Y": #3 is the pos for null info
	    return 'optional'
	return ''

